Further integration of YhLu's patch for nvidia AM2 boards.

Signed-off-by: Stefan Reinauer <stepan@coresystems.de>

Index: src/mainboard/supermicro/h8dmr/Config.lb
===================================================================
--- src/mainboard/supermicro/h8dmr/Config.lb	(revision 2560)
+++ src/mainboard/supermicro/h8dmr/Config.lb	(working copy)
@@ -41,12 +41,12 @@
 ## The linuxBIOS bootloader.
 ##
 default PAYLOAD_SIZE            = ( ROM_SECTION_SIZE - ROM_IMAGE_SIZE )
-default CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+default CONFIG_ROM_PAYLOAD_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
 
 ##
 ## Compute where this copy of linuxBIOS will start in the boot rom
 ##
-default _ROMBASE      = ( CONFIG_ROM_STREAM_START + PAYLOAD_SIZE )
+default _ROMBASE      = ( CONFIG_ROM_PAYLOAD_START + PAYLOAD_SIZE )
 
 ##
 ## Compute a range of ROM that can cached to speed up linuxBIOS,
Index: src/mainboard/supermicro/h8dmr/Options.lb
===================================================================
--- src/mainboard/supermicro/h8dmr/Options.lb	(revision 2560)
+++ src/mainboard/supermicro/h8dmr/Options.lb	(working copy)
@@ -42,11 +42,11 @@
 uses ROM_IMAGE_SIZE
 uses ROM_SECTION_SIZE
 uses ROM_SECTION_OFFSET
-uses CONFIG_ROM_STREAM
-uses CONFIG_ROM_STREAM_START
-uses CONFIG_COMPRESSED_ROM_STREAM
-uses CONFIG_COMPRESSED_ROM_STREAM_LZMA
-uses CONFIG_PRECOMPRESSED_ROM_STREAM
+uses CONFIG_ROM_PAYLOAD
+uses CONFIG_ROM_PAYLOAD_START
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
+uses CONFIG_COMPRESSED_PAYLOAD_LZMA
+uses CONFIG_PRECOMPRESSED_PAYLOAD
 uses PAYLOAD_SIZE
 uses _ROMBASE
 uses XIP_ROM_SIZE
@@ -283,9 +283,9 @@
 ##
 ## Load the payload from the ROM
 ##
-default CONFIG_ROM_STREAM = 1
+default CONFIG_ROM_PAYLOAD = 1
 
-#default CONFIG_COMPRESSED_ROM_STREAM = 1
+#default CONFIG_COMPRESSED_PAYLOAD = 1
 
 ###
 ### Defaults of options that you may want to override in the target config file
Index: src/mainboard/gigabyte/m57sli/Config.lb
===================================================================
--- src/mainboard/gigabyte/m57sli/Config.lb	(revision 2560)
+++ src/mainboard/gigabyte/m57sli/Config.lb	(working copy)
@@ -41,12 +41,12 @@
 ## The linuxBIOS bootloader.
 ##
 default PAYLOAD_SIZE            = ( ROM_SECTION_SIZE - ROM_IMAGE_SIZE )
-default CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+default CONFIG_ROM_PAYLOAD_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
 
 ##
 ## Compute where this copy of linuxBIOS will start in the boot rom
 ##
-default _ROMBASE      = ( CONFIG_ROM_STREAM_START + PAYLOAD_SIZE )
+default _ROMBASE      = ( CONFIG_ROM_PAYLOAD_START + PAYLOAD_SIZE )
 
 ##
 ## Compute a range of ROM that can cached to speed up linuxBIOS,
Index: src/mainboard/gigabyte/m57sli/Options.lb
===================================================================
--- src/mainboard/gigabyte/m57sli/Options.lb	(revision 2560)
+++ src/mainboard/gigabyte/m57sli/Options.lb	(working copy)
@@ -42,11 +42,11 @@
 uses ROM_IMAGE_SIZE
 uses ROM_SECTION_SIZE
 uses ROM_SECTION_OFFSET
-uses CONFIG_ROM_STREAM
-uses CONFIG_ROM_STREAM_START
-uses CONFIG_COMPRESSED_ROM_STREAM
-uses CONFIG_COMPRESSED_ROM_STREAM_LZMA
-uses CONFIG_PRECOMPRESSED_ROM_STREAM
+uses CONFIG_ROM_PAYLOAD
+uses CONFIG_ROM_PAYLOAD_START
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
+uses CONFIG_COMPRESSED_PAYLOAD_LZMA
+uses CONFIG_PRECOMPRESSED_PAYLOAD
 uses PAYLOAD_SIZE
 uses _ROMBASE
 uses XIP_ROM_SIZE
@@ -286,9 +286,9 @@
 ##
 ## Load the payload from the ROM
 ##
-default CONFIG_ROM_STREAM = 1
+default CONFIG_ROM_PAYLOAD = 1
 
-#default CONFIG_COMPRESSED_ROM_STREAM = 1
+#default CONFIG_COMPRESSED_PAYLOAD_NRV2B = 1
 
 ###
 ### Defaults of options that you may want to override in the target config file
Index: src/mainboard/nvidia/l1_2pvv/Config.lb
===================================================================
--- src/mainboard/nvidia/l1_2pvv/Config.lb	(revision 2560)
+++ src/mainboard/nvidia/l1_2pvv/Config.lb	(working copy)
@@ -41,12 +41,12 @@
 ## The linuxBIOS bootloader.
 ##
 default PAYLOAD_SIZE            = ( ROM_SECTION_SIZE - ROM_IMAGE_SIZE )
-default CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+default CONFIG_ROM_PAYLOAD_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
 
 ##
 ## Compute where this copy of linuxBIOS will start in the boot rom
 ##
-default _ROMBASE      = ( CONFIG_ROM_STREAM_START + PAYLOAD_SIZE )
+default _ROMBASE      = ( CONFIG_ROM_PAYLOAD_START + PAYLOAD_SIZE )
 
 ##
 ## Compute a range of ROM that can cached to speed up linuxBIOS,
Index: src/mainboard/nvidia/l1_2pvv/Options.lb
===================================================================
--- src/mainboard/nvidia/l1_2pvv/Options.lb	(revision 2560)
+++ src/mainboard/nvidia/l1_2pvv/Options.lb	(working copy)
@@ -42,11 +42,11 @@
 uses ROM_IMAGE_SIZE
 uses ROM_SECTION_SIZE
 uses ROM_SECTION_OFFSET
-uses CONFIG_ROM_STREAM
-uses CONFIG_ROM_STREAM_START
-uses CONFIG_COMPRESSED_ROM_STREAM
-uses CONFIG_COMPRESSED_ROM_STREAM_LZMA
-uses CONFIG_PRECOMPRESSED_ROM_STREAM
+uses CONFIG_ROM_PAYLOAD
+uses CONFIG_ROM_PAYLOAD_START
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
+uses CONFIG_COMPRESSED_PAYLOAD_LZMA
+uses CONFIG_PRECOMPRESSED_PAYLOAD
 uses PAYLOAD_SIZE
 uses _ROMBASE
 uses XIP_ROM_SIZE
@@ -286,9 +286,9 @@
 ##
 ## Load the payload from the ROM
 ##
-default CONFIG_ROM_STREAM = 1
+default CONFIG_ROM_PAYLOAD = 1
 
-#default CONFIG_COMPRESSED_ROM_STREAM = 1
+#default CONFIG_COMPRESSED_PAYLOAD = 1
 
 ###
 ### Defaults of options that you may want to override in the target config file
Index: src/mainboard/tyan/s2912/Config.lb
===================================================================
--- src/mainboard/tyan/s2912/Config.lb	(revision 2560)
+++ src/mainboard/tyan/s2912/Config.lb	(working copy)
@@ -41,12 +41,12 @@
 ## The linuxBIOS bootloader.
 ##
 default PAYLOAD_SIZE            = ( ROM_SECTION_SIZE - ROM_IMAGE_SIZE )
-default CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+default CONFIG_ROM_PAYLOAD_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
 
 ##
 ## Compute where this copy of linuxBIOS will start in the boot rom
 ##
-default _ROMBASE      = ( CONFIG_ROM_STREAM_START + PAYLOAD_SIZE )
+default _ROMBASE      = ( CONFIG_ROM_PAYLOAD_START + PAYLOAD_SIZE )
 
 ##
 ## Compute a range of ROM that can cached to speed up linuxBIOS,
Index: src/mainboard/tyan/s2912/Options.lb
===================================================================
--- src/mainboard/tyan/s2912/Options.lb	(revision 2560)
+++ src/mainboard/tyan/s2912/Options.lb	(working copy)
@@ -42,11 +42,11 @@
 uses ROM_IMAGE_SIZE
 uses ROM_SECTION_SIZE
 uses ROM_SECTION_OFFSET
-uses CONFIG_ROM_STREAM
-uses CONFIG_ROM_STREAM_START
-uses CONFIG_COMPRESSED_ROM_STREAM
-uses CONFIG_COMPRESSED_ROM_STREAM_LZMA
-uses CONFIG_PRECOMPRESSED_ROM_STREAM
+uses CONFIG_ROM_PAYLOAD
+uses CONFIG_ROM_PAYLOAD_START
+uses CONFIG_COMPRESSED_PAYLOAD_NRV2B
+uses CONFIG_COMPRESSED_PAYLOAD_LZMA
+uses CONFIG_PRECOMPRESSED_PAYLOAD
 uses PAYLOAD_SIZE
 uses _ROMBASE
 uses XIP_ROM_SIZE
@@ -288,9 +288,9 @@
 ##
 ## Load the payload from the ROM
 ##
-default CONFIG_ROM_STREAM = 1
+default CONFIG_ROM_PAYLOAD = 1
 
-#default CONFIG_COMPRESSED_ROM_STREAM = 1
+#default CONFIG_COMPRESSED_PAYLOAD = 1
 
 ###
 ### Defaults of options that you may want to override in the target config file
Index: targets/supermicro/h8dmr/Config.lb.kernel
===================================================================
--- targets/supermicro/h8dmr/Config.lb.kernel	(revision 2560)
+++ targets/supermicro/h8dmr/Config.lb.kernel	(working copy)
@@ -28,8 +28,8 @@
 romimage "fallback" 
 	option USE_FAILOVER_IMAGE=0
 	option USE_FALLBACK_IMAGE=1
-	option CONFIG_COMPRESSED_ROM_STREAM_LZMA=1
-	option CONFIG_PRECOMPRESSED_ROM_STREAM=1
+	option CONFIG_COMPRESSED_PAYLOAD_LZMA=1
+	option CONFIG_PRECOMPRESSED_PAYLOAD=1
 #	option ROM_IMAGE_SIZE=0x19800
 	option ROM_IMAGE_SIZE=0x18000
 #	option ROM_IMAGE_SIZE=0x15800
Index: targets/gigabyte/m57sli/Config.lb.kernel
===================================================================
--- targets/gigabyte/m57sli/Config.lb.kernel	(revision 2560)
+++ targets/gigabyte/m57sli/Config.lb.kernel	(working copy)
@@ -30,8 +30,8 @@
 romimage "fallback" 
 	option USE_FAILOVER_IMAGE=0
 	option USE_FALLBACK_IMAGE=1
-	option CONFIG_COMPRESSED_ROM_STREAM_LZMA=1
-	option CONFIG_PRECOMPRESSED_ROM_STREAM=1
+	option CONFIG_COMPRESSED_PAYLOAD_LZMA=1
+	option CONFIG_PRECOMPRESSED_PAYLOAD=1
 #	option ROM_IMAGE_SIZE=0x19800
 	option ROM_IMAGE_SIZE=0x17000
 #	option ROM_IMAGE_SIZE=0x15800
Index: targets/tyan/s2912/Config.lb.kernel
===================================================================
--- targets/tyan/s2912/Config.lb.kernel	(revision 2560)
+++ targets/tyan/s2912/Config.lb.kernel	(working copy)
@@ -30,8 +30,8 @@
 romimage "fallback" 
 	option USE_FAILOVER_IMAGE=0
 	option USE_FALLBACK_IMAGE=1
-	option CONFIG_COMPRESSED_ROM_STREAM_LZMA=1
-	option CONFIG_PRECOMPRESSED_ROM_STREAM=1
+	option CONFIG_COMPRESSED_PAYLOAD_LZMA=1
+	option CONFIG_PRECOMPRESSED_PAYLOAD=1
 #	option ROM_IMAGE_SIZE=0x19800
 	option ROM_IMAGE_SIZE=0x17000
 #	option ROM_IMAGE_SIZE=0x15800
Index: targets/nvidia/l1_2pvv/Config.lb.kernel
===================================================================
--- targets/nvidia/l1_2pvv/Config.lb.kernel	(revision 2560)
+++ targets/nvidia/l1_2pvv/Config.lb.kernel	(working copy)
@@ -32,8 +32,8 @@
 romimage "fallback" 
 	option USE_FAILOVER_IMAGE=0
 	option USE_FALLBACK_IMAGE=1
-	option CONFIG_COMPRESSED_ROM_STREAM_LZMA=1
-	option CONFIG_PRECOMPRESSED_ROM_STREAM=1
+	option CONFIG_COMPRESSED_PAYLOAD_LZMA=1
+	option CONFIG_PRECOMPRESSED_PAYLOAD=1
 #	option ROM_IMAGE_SIZE=0x19800
 	option ROM_IMAGE_SIZE=0x17000
 #	option ROM_IMAGE_SIZE=0x15800